ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.20 by greg, Sat Jun 4 00:33:53 2011 UTC vs.
Revision 2.39 by greg, Mon Sep 10 18:06:08 2012 UTC

# Line 8 | Line 8
8   use strict;
9   use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12          exit 1;
13   }
14   my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
# Line 16 | Line 16 | chomp $td;
16   my @savedARGV = @ARGV;
17   my $tensortree = 0;
18   my $ttlog2 = 4;
19 < my $nsamp = 1000;
19 > my $nsamp = 2000;
20   my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21   my $mgfin = 0;
22   my $geout = 1;
23   my $nproc = 1;
24   my $doforw = 0;
25   my $doback = 1;
26 + my $pctcull = 90;
27 + my $gunit = "Meter";
28   my @dim;
29   # Get options
30   while ($#ARGV >= 0) {
# Line 33 | Line 35 | while ($#ARGV >= 0) {
35                  shift @ARGV;
36          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
37                  $geout = ("$ARGV[0]" =~ /^\+/);
38 +                $gunit = $ARGV[1];
39 +                if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
40 +                        die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
41 +                }
42 +                shift @ARGV;
43          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
44                  $doforw = ("$ARGV[0]" =~ /^\+/);
45          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46                  $doback = ("$ARGV[0]" =~ /^\+/);
47 +        } elsif ("$ARGV[0]" eq "-t") {
48 +                # Use value < 0 for rttree_reduce bypass
49 +                $pctcull = $ARGV[1];
50 +                shift @ARGV;
51          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52                  $tensortree = substr($ARGV[0], 2, 1);
53                  $ttlog2 = $ARGV[1];
# Line 60 | Line 71 | while ($#ARGV >= 0) {
71   }
72   # Check that we're actually being asked to do something
73   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
63 # Name our own persist file?
64 my $persistfile;
65 if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
66        $persistfile = "$td/pfile.txt";
67        $rtargs = "-PP $persistfile $rtargs";
68 }
74   # Get scene description and dimensions
75   my $radscn = "$td/device.rad";
76   my $mgfscn = "$td/device.mgf";
# Line 109 | Line 114 | print
114                  <Name>Name</Name>
115                  <Manufacturer>Manufacturer</Manufacturer>
116   ';
117 < printf "\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
118 < printf "\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
119 < printf "\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
117 > printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
118 > printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
119 > printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
120   print "\t\t<DeviceType>Integral</DeviceType>\n";
121   # Output MGF description if requested
122   if ( $geout ) {
123 <        print "\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
123 >        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
124          printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
125          open(MGFSCN, "< $mgfscn");
126          while (<MGFSCN>) { print $_; }
# Line 143 | Line 148 | print
148   </WindowElement>
149   ';
150   # Clean up temporary files and exit
146 if ( $persistfile && open(PFI, "< $persistfile") ) {
147        while (<PFI>) {
148                s/^[^ ]* //;
149                kill('ALRM', $_);
150                last;
151        }
152        close PFI;
153 }
151   exec("rm -rf $td");
152  
153   #-------------- End of main program segment --------------#
154  
155   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
156   sub do_tree_bsdf {
160 # Get sampling rate and subdivide task
161 my $ns2 = $ns;
162 $ns2 /= 2 if ( $tensortree == 3 );
163 @pdiv = (0, int($ns2/$nproc));
164 my $nrem = $ns2 % $nproc;
165 for (my $i = 1; $i < $nproc; $i++) {
166        my $nv = $pdiv[$i] + $pdiv[1];
167        ++$nv if ( $nrem-- > 0 );
168        push @pdiv, $nv;
169 }
170 die "Script error 1" if ($pdiv[-1] != $ns2);
157   # Shirley-Chiu mapping from unit square to disk
158   $sq2disk = '
159   in_square_a = 2*in_square_x - 1;
# Line 210 | Line 196 | out_square_y = (out_square_b + 1)/2;
196   print "\t<DataDefinition>\n";
197   print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
198   print "\t</DataDefinition>\n";
199 < # Fork parallel rtcontrib processes to compute each side
200 < if ( $doback ) {
201 <        for (my $proc = 0; $proc < $nproc; $proc++) {
202 <                bg_tree_rtcontrib(0, $proc);
203 <        }
218 <        while (wait() >= 0) {
219 <                die "rtcontrib process reported error" if ( $? );
220 <        }
221 <        ttree_out(0);
222 < }
223 < if ( $doforw ) {
224 <        for (my $proc = 0; $proc < $nproc; $proc++) {
225 <                bg_tree_rtcontrib(1, $proc);
226 <        }
227 <        while (wait() >= 0) {
228 <                die "rtcontrib process reported error" if ( $? );
229 <        }
230 <        ttree_out(1);
231 < }
199 >
200 > # Start rcontrib processes for compute each side
201 > do_tree_rtcontrib(0) if ( $doback );
202 > do_tree_rtcontrib(1) if ( $doforw );
203 >
204   }       # end of sub do_tree_bsdf()
205  
206 < # Run i'th rtcontrib process for generating tensor tree samples
207 < sub bg_tree_rtcontrib {
236 <        my $pid = fork();
237 <        die "Cannot fork new process" unless defined $pid;
238 <        if ($pid > 0) { return $pid; }
206 > # Run rcontrib process to generate tensor tree samples
207 > sub do_tree_rtcontrib {
208          my $forw = shift;
240        my $pn = shift;
241        my $pbeg = $pdiv[$pn];
242        my $plen = $pdiv[$pn+1] - $pbeg;
209          my $matargs = "-m $bmodnm";
210 <        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
211 <        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
210 >        if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
211 >        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
212                  "-e '$disk2sq' -bn '$ns*$ns' " .
213                  "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
214 <                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
214 >                "-o $td/%s.flt $matargs $octree";
215          if ( $tensortree == 3 ) {
216                  # Isotropic BSDF
217 <                $cmd = "cnt $plen $ny $nx " .
218 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
219 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
220 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
221 <                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
217 >                my $ns2 = $ns / 2;
218 >                $cmd = "cnt $ns2 $ny $nx " .
219 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
220 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
221 >                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
222 >                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
223                          "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
224                          "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
225                          "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
# Line 263 | Line 230 | sub bg_tree_rtcontrib {
230                  # Anisotropic BSDF
231                  # Sample area vertically to improve load balance, since
232                  # shading systems usually have bilateral symmetry (L-R)
233 <                $cmd = "cnt $plen $ns $ny $nx " .
234 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
235 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
236 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
237 <                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
238 <                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
233 >                $cmd = "cnt $ns $ns $ny $nx " .
234 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
235 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
236 >                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
237 >                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
238 >                        "-e 'in_square_x=(\$1+r1)/$ns' " .
239                          "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
240                          "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
241                          "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
# Line 278 | Line 245 | sub bg_tree_rtcontrib {
245                          "| $cmd";
246          }
247   # print STDERR "Starting: $cmd\n";
248 <        exec($cmd);             # no return; status report to parent via wait
249 <        die "Cannot exec: $cmd\n";
250 < }       # end of bg_tree_rtcontrib()
248 >        system "$cmd" || die "Failure running rcontrib";
249 >        ttree_out($forw);
250 > }       # end of do_tree_rtcontrib()
251  
252   # Simplify and output tensor tree results
253   sub ttree_out {
254          my $forw = shift;
255          my $side = ("Back","Front")[$forw];
256 < # Only output one transmitted distribution, preferring backwards
257 < if ( !$forw || !$doback ) {
256 >        my $cmd;
257 > # Only output one transmitted anisotropic distribution, preferring backwards
258 > if ( !$forw || !$doback || $tensortree==3 ) {
259   print
260   '       <WavelengthData>
261                  <LayerNumber>System</LayerNumber>
# Line 295 | Line 263 | print
263                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
264                  <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
265                  <WavelengthDataBlock>
266 <                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
267 <                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
266 > ';
267 > print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
268 > print
269 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
270                          <ScatteringDataType>BTDF</ScatteringDataType>
271                          <ScatteringData>
272   ';
273 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
274 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
275 <        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
276 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
277 < die "Failure running rttree_reduce" if ( $? );
273 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
274 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
275 > if ($pctcull >= 0) {
276 >        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
277 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
278 >        system "$cmd" || die "Failure running rttree_reduce";
279 > } else {
280 >        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
281 >        print "{\n";
282 >        system "$cmd" || die "Failure running rcalc";
283 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
284 >                print "0\n";
285 >        }
286 >        print "}\n";
287 > }
288   print
289   '                       </ScatteringData>
290                  </WavelengthDataBlock>
# Line 326 | Line 306 | print
306                          <ScatteringDataType>BRDF</ScatteringDataType>
307                          <ScatteringData>
308   ';
309 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
310 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
311 <        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
312 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
313 < die "Failure running rttree_reduce" if ( $? );
309 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
310 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
311 > if ($pctcull >= 0) {
312 >        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
313 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
314 >        system "$cmd" || die "Failure running rttree_reduce";
315 > } else {
316 >        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
317 >        print "{\n";
318 >        system "$cmd" || die "Failure running rcalc";
319 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
320 >                print "0\n";
321 >        }
322 >        print "}\n";
323 > }
324   print
325   '                       </ScatteringData>
326                  </WavelengthDataBlock>
# Line 347 | Line 337 | sub do_matrix_bsdf {
337   $tcal = '
338   DEGREE : PI/180;
339   sq(x) : x*x;
340 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
340 > Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
341   Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
342   Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
343   Kmax : Kaccum(Knaz(0));
# Line 368 | Line 358 | KprojOmega = PI * if(Kbin-.5,
358   $kcal = '
359   DEGREE : PI/180;
360   abs(x) : if(x, x, -x);
361 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
361 > Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
362   posangle(a) : if(-a, a + 2*PI, a);
363 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
363 > Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
364   kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
365   knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
366   kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
# Line 391 | Line 381 | kbin2(pol,azi) = select(kfindrow(1, pol),
381   kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
382   ';
383   my $ndiv = 145;
384 < # Compute scattering data using rtcontrib
384 > # Compute scattering data using rcontrib
385   my @tfarr;
386   my @rfarr;
387   my @tbarr;
388   my @rbarr;
389   my $cmd;
390 < my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
390 > my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
391          "-e '$kcal' -b kbin -bn $ndiv " .
392          "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
393   my $rccmd = "rcalc -e '$tcal' " .
394          "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
395 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
395 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
396   if ( $doforw ) {
397   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
398          "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
# Line 414 | Line 404 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
404   system "$cmd" || die "Failure running: $cmd\n";
405   @tfarr = `$rccmd $td/$fmodnm.flt`;
406   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
407 + chomp(@tfarr);
408   @rfarr = `$rccmd $td/$bmodnm.flt`;
409   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
410 + chomp(@rfarr);
411   }
412   if ( $doback ) {
413   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
# Line 428 | Line 420 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
420   system "$cmd" || die "Failure running: $cmd\n";
421   @tbarr = `$rccmd $td/$bmodnm.flt`;
422   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
423 + chomp(@tbarr);
424   @rbarr = `$rccmd $td/$fmodnm.flt`;
425   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
426 + chomp(@rbarr);
427   }
428   # Output angle basis
429   print
# Line 438 | Line 432 | print
432                  <AngleBasis>
433                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
434                          <AngleBasisBlock>
435 <                                <Theta>0</Theta>
436 <                                <nPhis>1</nPhis>
437 <                                <ThetaBounds>
438 <                                        <LowerTheta>0</LowerTheta>
439 <                                        <UpperTheta>5</UpperTheta>
440 <                                </ThetaBounds>
447 <                                </AngleBasisBlock>
448 <                                <AngleBasisBlock>
449 <                                <Theta>10</Theta>
450 <                                <nPhis>8</nPhis>
451 <                                <ThetaBounds>
452 <                                        <LowerTheta>5</LowerTheta>
453 <                                        <UpperTheta>15</UpperTheta>
454 <                                </ThetaBounds>
455 <                                </AngleBasisBlock>
456 <                                <AngleBasisBlock>
457 <                                <Theta>20</Theta>
458 <                                <nPhis>16</nPhis>
459 <                                <ThetaBounds>
460 <                                        <LowerTheta>15</LowerTheta>
461 <                                        <UpperTheta>25</UpperTheta>
462 <                                </ThetaBounds>
463 <                                </AngleBasisBlock>
464 <                                <AngleBasisBlock>
465 <                                <Theta>30</Theta>
466 <                                <nPhis>20</nPhis>
467 <                                <ThetaBounds>
468 <                                        <LowerTheta>25</LowerTheta>
469 <                                        <UpperTheta>35</UpperTheta>
470 <                                </ThetaBounds>
471 <                                </AngleBasisBlock>
472 <                                <AngleBasisBlock>
473 <                                <Theta>40</Theta>
474 <                                <nPhis>24</nPhis>
475 <                                <ThetaBounds>
476 <                                        <LowerTheta>35</LowerTheta>
477 <                                        <UpperTheta>45</UpperTheta>
478 <                                </ThetaBounds>
479 <                                </AngleBasisBlock>
480 <                                <AngleBasisBlock>
481 <                                <Theta>50</Theta>
482 <                                <nPhis>24</nPhis>
483 <                                <ThetaBounds>
484 <                                        <LowerTheta>45</LowerTheta>
485 <                                        <UpperTheta>55</UpperTheta>
486 <                                </ThetaBounds>
487 <                                </AngleBasisBlock>
488 <                                <AngleBasisBlock>
489 <                                <Theta>60</Theta>
490 <                                <nPhis>24</nPhis>
491 <                                <ThetaBounds>
492 <                                        <LowerTheta>55</LowerTheta>
493 <                                        <UpperTheta>65</UpperTheta>
494 <                                </ThetaBounds>
495 <                                </AngleBasisBlock>
496 <                                <AngleBasisBlock>
497 <                                <Theta>70</Theta>
498 <                                <nPhis>16</nPhis>
499 <                                <ThetaBounds>
500 <                                        <LowerTheta>65</LowerTheta>
501 <                                        <UpperTheta>75</UpperTheta>
502 <                                </ThetaBounds>
503 <                                </AngleBasisBlock>
504 <                                <AngleBasisBlock>
505 <                                <Theta>82.5</Theta>
506 <                                <nPhis>12</nPhis>
507 <                                <ThetaBounds>
508 <                                        <LowerTheta>75</LowerTheta>
509 <                                        <UpperTheta>90</UpperTheta>
510 <                                </ThetaBounds>
435 >                        <Theta>0</Theta>
436 >                        <nPhis>1</nPhis>
437 >                        <ThetaBounds>
438 >                                <LowerTheta>0</LowerTheta>
439 >                                <UpperTheta>5</UpperTheta>
440 >                        </ThetaBounds>
441                          </AngleBasisBlock>
442 +                        <AngleBasisBlock>
443 +                        <Theta>10</Theta>
444 +                        <nPhis>8</nPhis>
445 +                        <ThetaBounds>
446 +                                <LowerTheta>5</LowerTheta>
447 +                                <UpperTheta>15</UpperTheta>
448 +                        </ThetaBounds>
449 +                        </AngleBasisBlock>
450 +                        <AngleBasisBlock>
451 +                        <Theta>20</Theta>
452 +                        <nPhis>16</nPhis>
453 +                        <ThetaBounds>
454 +                                <LowerTheta>15</LowerTheta>
455 +                                <UpperTheta>25</UpperTheta>
456 +                        </ThetaBounds>
457 +                        </AngleBasisBlock>
458 +                        <AngleBasisBlock>
459 +                        <Theta>30</Theta>
460 +                        <nPhis>20</nPhis>
461 +                        <ThetaBounds>
462 +                                <LowerTheta>25</LowerTheta>
463 +                                <UpperTheta>35</UpperTheta>
464 +                        </ThetaBounds>
465 +                        </AngleBasisBlock>
466 +                        <AngleBasisBlock>
467 +                        <Theta>40</Theta>
468 +                        <nPhis>24</nPhis>
469 +                        <ThetaBounds>
470 +                                <LowerTheta>35</LowerTheta>
471 +                                <UpperTheta>45</UpperTheta>
472 +                        </ThetaBounds>
473 +                        </AngleBasisBlock>
474 +                        <AngleBasisBlock>
475 +                        <Theta>50</Theta>
476 +                        <nPhis>24</nPhis>
477 +                        <ThetaBounds>
478 +                                <LowerTheta>45</LowerTheta>
479 +                                <UpperTheta>55</UpperTheta>
480 +                        </ThetaBounds>
481 +                        </AngleBasisBlock>
482 +                        <AngleBasisBlock>
483 +                        <Theta>60</Theta>
484 +                        <nPhis>24</nPhis>
485 +                        <ThetaBounds>
486 +                                <LowerTheta>55</LowerTheta>
487 +                                <UpperTheta>65</UpperTheta>
488 +                        </ThetaBounds>
489 +                        </AngleBasisBlock>
490 +                        <AngleBasisBlock>
491 +                        <Theta>70</Theta>
492 +                        <nPhis>16</nPhis>
493 +                        <ThetaBounds>
494 +                                <LowerTheta>65</LowerTheta>
495 +                                <UpperTheta>75</UpperTheta>
496 +                        </ThetaBounds>
497 +                        </AngleBasisBlock>
498 +                        <AngleBasisBlock>
499 +                        <Theta>82.5</Theta>
500 +                        <nPhis>12</nPhis>
501 +                        <ThetaBounds>
502 +                                <LowerTheta>75</LowerTheta>
503 +                                <UpperTheta>90</UpperTheta>
504 +                        </ThetaBounds>
505 +                        </AngleBasisBlock>
506                  </AngleBasis>
507          </DataDefinition>
508   ';
# Line 529 | Line 523 | print
523   # Output front transmission (transposed order)
524   for (my $od = 0; $od < $ndiv; $od++) {
525          for (my $id = 0; $id < $ndiv; $id++) {
526 <                print $tfarr[$ndiv*$id + $od];
526 >                print $tfarr[$ndiv*$id + $od], ",\n";
527          }
528          print "\n";
529   }
# Line 552 | Line 546 | print
546   # Output front reflection (transposed order)
547   for (my $od = 0; $od < $ndiv; $od++) {
548          for (my $id = 0; $id < $ndiv; $id++) {
549 <                print $rfarr[$ndiv*$id + $od];
549 >                print $rfarr[$ndiv*$id + $od], ",\n";
550          }
551          print "\n";
552   }
# Line 579 | Line 573 | print
573   # Output back transmission (transposed order)
574   for (my $od = 0; $od < $ndiv; $od++) {
575          for (my $id = 0; $id < $ndiv; $id++) {
576 <                print $tbarr[$ndiv*$id + $od];
576 >                print $tbarr[$ndiv*$id + $od], ",\n";
577          }
578          print "\n";
579   }
# Line 602 | Line 596 | print
596   # Output back reflection (transposed order)
597   for (my $od = 0; $od < $ndiv; $od++) {
598          for (my $id = 0; $id < $ndiv; $id++) {
599 <                print $rbarr[$ndiv*$id + $od];
599 >                print $rbarr[$ndiv*$id + $od], ",\n";
600          }
601          print "\n";
602   }

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines